import { StateEffect as B, StateField as D, EditorState as N } from "@codemirror/state";
import { EditorView as i, Decoration as a, lineNumbers as E, highlightActiveLineGutter as H, keymap as k } from "@codemirror/view";
import { defaultKeymap as L } from "@codemirror/commands";
import { HighlightStyle as M, syntaxHighlighting as S, defaultHighlightStyle as T } from "@codemirror/language";
import { javascript as A } from "@codemirror/lang-javascript";
import { tags as o } from "@lezer/highlight";
const G = "#e5c07b", C = "#e06c75", K = "#56b6c2", W = "#ffffff", m = "#abb2bf", g = "#7d8799", j = "#61afef", I = "#98c379", y = "#d19a66", P = "#c678dd", V = "#21252b", v = "#2c313a", w = "#282c34", f = "#353a42", q = "#3E4451", x = "#528bff", z = i.theme(
  {
    "&": {
      color: m,
      backgroundColor: w
    },
    ".cm-content": {
      caretColor: x
    },
    ".cm-cursor, .cm-dropCursor": { borderLeftColor: x },
    "&.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: q },
    ".cm-panels": { backgroundColor: V, color: m },
    ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
    ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
    ".cm-searchMatch": {
      backgroundColor: "#72a1ff59",
      outline: "1px solid #457dff"
    },
    ".cm-searchMatch.cm-searchMatch-selected": {
      backgroundColor: "#6199ff2f"
    },
    ".cm-activeLine": { backgroundColor: "#6699ff0b" },
    ".cm-selectionMatch": { backgroundColor: "#aafe661a" },
    "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
      backgroundColor: "#bad0f847"
    },
    ".cm-gutters": {
      backgroundColor: w,
      color: g,
      border: "none"
    },
    ".cm-activeLineGutter": {
      backgroundColor: v
    },
    ".cm-foldPlaceholder": {
      backgroundColor: "transparent",
      border: "none",
      color: "#ddd"
    },
    ".cm-tooltip": {
      border: "none",
      backgroundColor: f
    },
    ".cm-tooltip .cm-tooltip-arrow:before": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    },
    ".cm-tooltip .cm-tooltip-arrow:after": {
      borderTopColor: f,
      borderBottomColor: f
    },
    ".cm-tooltip-autocomplete": {
      "& > ul > li[aria-selected]": {
        backgroundColor: v,
        color: m
      }
    }
  },
  { dark: !0 }
), J = M.define([
  { tag: o.keyword, color: P },
  { tag: [o.name, o.deleted, o.character, o.propertyName, o.macroName], color: C },
  { tag: [o.function(o.variableName), o.labelName], color: j },
  { tag: [o.color, o.constant(o.name), o.standard(o.name)], color: y },
  { tag: [o.definition(o.name), o.separator], color: m },
  { tag: [o.typeName, o.className, o.number, o.changed, o.annotation, o.modifier, o.self, o.namespace], color: G },
  { tag: [o.operator, o.operatorKeyword, o.url, o.escape, o.regexp, o.link, o.special(o.string)], color: K },
  { tag: [o.meta, o.comment], color: g },
  { tag: o.strong, fontWeight: "bold" },
  { tag: o.emphasis, fontStyle: "italic" },
  { tag: o.strikethrough, textDecoration: "line-through" },
  { tag: o.link, color: g, textDecoration: "underline" },
  { tag: o.heading, fontWeight: "bold", color: C },
  { tag: [o.atom, o.bool, o.special(o.variableName)], color: y },
  { tag: [o.processingInstruction, o.string, o.inserted], color: I },
  { tag: o.invalid, color: W }
]), O = [z, S(J)];
function Q({ initialCode: e = "", onChange: t, onEvaluate: r, onStop: c, theme: n = O, root: l }) {
  let s = N.create({
    doc: e,
    extensions: [
      n,
      A(),
      E(),
      R,
      H(),
      S(T),
      k.of(L),
      X,
      i.updateListener.of((d) => t(d)),
      k.of([
        {
          key: "Ctrl-Enter",
          run: () => r()
        },
        {
          key: "Ctrl-.",
          run: () => c()
        }
      ])
    ]
  });
  return new i({
    state: s,
    parent: l
  });
}
const F = B.define(), R = D.define({
  create() {
    return a.none;
  },
  update(e, t) {
    try {
      for (let r of t.effects)
        if (r.is(F)) {
          const { haps: c } = r.value, n = c.map(
            (l) => (l.context.locations || []).map(({ start: s, end: d }) => {
              let h = t.newDoc.line(s.line).from + s.column, p = t.newDoc.line(d.line).from + d.column;
              const b = t.newDoc.length;
              return h > b || p > b ? void 0 : a.mark({
                attributes: { style: "outline: 2px solid #FFCA28;" }
              }).range(h, p);
            })
          ).flat().filter(Boolean) || [];
          e = a.set(n, !0);
        }
      return e;
    } catch {
      return a.set([]);
    }
  },
  provide: (e) => i.decorations.from(e)
});
function U(e, t) {
  e.dispatch({ effects: F.of({ haps: t }) });
}
const u = B.define(), X = D.define({
  create() {
    return a.none;
  },
  update(e, t) {
    try {
      for (let r of t.effects)
        if (r.is(u))
          if (r.value) {
            const c = a.mark({ attributes: { style: "background-color: #FFCA2880" } });
            e = a.set([c.range(0, t.newDoc.length)]);
          } else
            e = a.set([]);
      return e;
    } catch (r) {
      return console.warn("flash error", r), e;
    }
  },
  provide: (e) => i.decorations.from(e)
}), Y = (e, t = 200) => {
  e.dispatch({ effects: u.of(!0) }), setTimeout(() => {
    e.dispatch({ effects: u.of(!1) });
  }, t);
};
class ao {
  constructor({ root: t, initialCode: r = "", onEvaluate: c, onStop: n }) {
    this.code = r, this.view = Q({
      root: t,
      initialCode: r,
      onChange: (l) => {
        this.code = l.state.doc.toString();
      },
      onEvaluate: c,
      onStop: n
    });
  }
  flash(t) {
    Y(this.view, t);
  }
  highlight(t) {
    U(this.view, t);
  }
}
export {
  ao as StrudelMirror,
  Y as flash,
  R as highlightField,
  U as highlightHaps,
  Q as initEditor,
  u as setFlash,
  F as setHighlights
};
